clear all;
close all;

Kvc = 3.2e-3;
R = 4.1;
L = 16.1e-3;
J = 2e-7;
r = 1e-2;

ks = 55e-6;
ds = 1e-5;
dt = 0.008;

A = [-R/L        0    -(Kvc*r)/L;
      0          0     1;
      (Kvc*r)/J -ks/J -ds/J];
B = [1/L;
     0;
     0];
C = [0 1 0];
D = 0;

sysc = ss(A, B, C, D);
sys = c2d(sysc, dt)

Qn1 = 0.5;
Qn = sys.b * Qn1 * sys.b';
Rn = 16e-5;

%[kest, Lk, Pk, Mk] = kalman(sys, Qn1, Rn);
n = 300;
P = cell(n, 1);
K = cell(n, 1);
Pmin = cell(n, 1);
P{1} = zeros(3);
Pmin{1} = Qn;
K{1} = zeros(3, 1);
xhatmin = [0; 0; 0];
xhat = [0; 0; 0];
for i = 2:n
    Kn = Pmin{i - 1} * sys.C' / (sys.C * Pmin{i - 1} * sys.C' + Rn);
    Pn = (eye(3) - Kn * sys.C) * Pmin{i - 1};
    Pminn = sys.A * Pn * sys.A' + Qn;
    K{i} = Kn;
    P{i} = Pn;
    Pmin{i} = Pminn;
end
Kn