clear all;

vibrations;

rtilt = 1e-2;
rpan = 1e-2;
r = blkdiag(rtilt, rpan); %Radius from center of rotation to coil force

J = 2e-7*eye(2);

%Voice coil actuator parameters
R = 4.1*eye(2); %Resistance in coil
L = 16e-3*eye(2); %Inductance in coil
Kvc = 3.2e-3*eye(2); %Voice coil constant

Fv = 1e-8;

A = [-R/L          zeros(2) -(Kvc*r)/L;
      zeros(2)     zeros(2)  eye(2);
      (Kvc*r)/(J)    zeros(2)  -Fv*eye(2)/J];
B = [inv(L);
     zeros(2);
     zeros(2)];
C = [zeros(2) eye(2) zeros(2)];
D = 0;

sys = ss(A, B, C, D);

%---------------------------------
%PID controller
%---------------------------------
PID.P = 2;
PID.I = 0;
PID.D = 1;

%---------------------------------
%LQG controller
%---------------------------------
%Kalman filter
obs.Qn = 10*eye(2);
obs.Rn = 1*eye(2);

[kest, obs.L, obs.P] = kalman(sys, obs.Qn, obs.Rn);

%lqr controller
lqrQ = blkdiag(0*eye(2), 1e6*eye(2), 0*eye(2));
lqrR = 1*eye(2);
[lqrK lqrS lqrE] = lqr(sys, lqrQ, lqrR);