#include "adc.h"

#include <avr/io.h>

void ADC_init() {

	//Set ADC pins as input pins
	//DDRF &= ~((1<<DDF0)|(1<<DDF1)|(1<<DDF2)|(1<<DDF3));
	//PORTF &= ~((1<<PF0)|(1<<PF1)|(1<<PF2)|(1<<PF3));

	//Voltage reference, AVCC with external capacitor at AREF pin
	ADMUX |= (1 << REFS0);

	//Set prescaler, division factor 64
	ADCSRA |= (1 << ADPS2) | (1 << ADPS1);

	//Enable ADC
	ADCSRA |= (1 << ADEN);
	ADCSRA |= (1 << ADSC);
}

uint16_t ADC_getValue(uint8_t channel) {

	uint16_t value;

	ADMUX &= 0xF8;
	ADMUX |= channel;

	//Start conversion
	ADCSRA |= (1 << ADSC);

	//Wait until ready
	while (ADCSRA & (1 << ADSC));

	//Read result
	value = ADCL;
	value += ADCH << 8;

	return value;

}
