#include "matrix.h"

#include <stdio.h>

Vector3 matxvec(Matrix33 mat, Vector3 vec) {

	Vector3 result;
	result.v1 = mat.v11 * vec.v1 + mat.v12 * vec.v2 + mat.v13*vec.v3;
	result.v2 = mat.v21 * vec.v1 + mat.v22 * vec.v2 + mat.v23*vec.v3;
	result.v3 = mat.v31 * vec.v1 + mat.v32 * vec.v2 + mat.v33*vec.v3;

	return result;
}

float innerproduct(Vector3 vec1, Vector3 vec2) {

	return vec1.v1 * vec2.v1 + 
	       vec1.v2 * vec2.v2 +
		   vec1.v3 * vec2.v3;
}

Vector3 vecxscalar(Vector3 vec, float num){

	Vector3 result;
	result.v1 = vec.v1*num;
	result.v2 = vec.v2*num;
	result.v3 = vec.v3*num;

	return result;
}

Vector3 vecplusvec(Vector3 vec1, Vector3 vec2) {

	Vector3 result;
	result.v1 = vec1.v1 + vec2.v1;
	result.v2 = vec1.v2 + vec2.v2;
	result.v3 = vec1.v3 + vec2.v3;

	return result;
}
